Index: /branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90
===================================================================
--- /branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 7885)
+++ /branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 7886)
@@ -3334,61 +3306,61 @@
                      !! this is the SURFACE OCEAN BOX (no remineralisation)
                      !!
-                     freminc  = 0.0
-                     freminn  = 0.0
-                     freminfe = 0.0
-                     freminsi = 0.0
-                     freminca = 0.0
-                  elseif (jk.le.jmbathy) then
+                     freminc(ji,jj)  = 0.0
+                     freminn(ji,jj)  = 0.0
+                     freminfe(ji,jj) = 0.0
+                     freminsi(ji,jj) = 0.0
+                     freminca(ji,jj) = 0.0
+                  elseif (jk.le.mbathy(ji,jj)) then
                      !! this is an OCEAN BOX (remineralise some material)
                      !!
                      !! === organic carbon ===
                      fq0      = ffastc(ji,jj)                        !! how much organic C enters this box        (mol)
-                     fq1      = fq0 * ((fdep1/fdep)**fb_val)         !! how much organic C leaves this box        (mol)
-                     freminc  = (fq0 - fq1) / fthk                   !! C remineralisation in this box            (mol)
+                     fq1      = fq0 * ((fdep1(ji,jj)/fsdepw(ji,jj,jk))**fb_val)         !! how much organic C leaves this box        (mol)
+                     freminc(ji,jj)  = (fq0 - fq1) / fse3t(ji,jj,jk)                   !! C remineralisation in this box            (mol)
                      ffastc(ji,jj)  = fq1
                      !!
                      !! === organic nitrogen ===
                      fq0      = ffastn(ji,jj)                        !! how much organic N enters this box        (mol)
-                     fq1      = fq0 * ((fdep1/fdep)**fb_val)         !! how much organic N leaves this box        (mol)
-                     freminn  = (fq0 - fq1) / fthk                   !! N remineralisation in this box            (mol)
+                     fq1      = fq0 * ((fdep1(ji,jj)/fsdepw(ji,jj,jk))**fb_val)         !! how much organic N leaves this box        (mol)
+                     freminn(ji,jj)  = (fq0 - fq1) / fse3t(ji,jj,jk)                   !! N remineralisation in this box            (mol)
                      ffastn(ji,jj)  = fq1
                      !!
                      !! === organic iron ===
                      fq0      = ffastfe(ji,jj)                       !! how much organic Fe enters this box       (mol)
-                     fq1      = fq0 * ((fdep1/fdep)**fb_val)         !! how much organic Fe leaves this box       (mol)
-                     freminfe = (fq0 - fq1) / fthk                   !! Fe remineralisation in this box           (mol)
+                     fq1      = fq0 * ((fdep1(ji,jj)/fsdepw(ji,jj,jk))**fb_val)         !! how much organic Fe leaves this box       (mol)
+                     freminfe(ji,jj) = (fq0 - fq1) / fse3t(ji,jj,jk)                   !! Fe remineralisation in this box           (mol)
                      ffastfe(ji,jj) = fq1
                      !!
                      !! === biogenic silicon ===
                      fq0      = ffastsi(ji,jj)                       !! how much  opal centers this box           (mol) 
-                     fq1      = fq0 * exp(-(fthk / xfastsi))         !! how much  opal leaves this box            (mol)
-                     freminsi = (fq0 - fq1) / fthk                   !! Si remineralisation in this box           (mol)
+                     fq1      = fq0 * exp(-(fse3t(ji,jj,jk) / xfastsi))         !! how much  opal leaves this box            (mol)
+                     freminsi(ji,jj) = (fq0 - fq1) / fse3t(ji,jj,jk)                   !! Si remineralisation in this box           (mol)
                      ffastsi(ji,jj) = fq1
                      !!
                      !! === biogenic calcium carbonate ===
                      fq0      = ffastca(ji,jj)                       !! how much CaCO3 enters this box            (mol)
-                     if (fdep.le.ocal_ccd(ji,jj)) then
+                     if (fsdepw(ji,jj,jk).le.ocal_ccd(ji,jj)) then
                         !! whole grid cell above CCD
                         fq1      = fq0                               !! above lysocline, no Ca dissolves          (mol)
-                        freminca = 0.0                               !! above lysocline, no Ca dissolves          (mol)
+                        freminca(ji,jj) = 0.0                               !! above lysocline, no Ca dissolves          (mol)
                         fccd(ji,jj) = real(jk)                       !! which is the last level above the CCD?    (#)
-                     elseif (fdep.ge.ocal_ccd(ji,jj)) then
+                     elseif (fsdepw(ji,jj,jk).ge.ocal_ccd(ji,jj)) then
                         !! whole grid cell below CCD
-                        fq1      = fq0 * exp(-(fthk / xfastca))      !! how much CaCO3 leaves this box            (mol)
-                        freminca = (fq0 - fq1) / fthk                !! Ca remineralisation in this box           (mol)
+                        fq1      = fq0 * exp(-(fse3t(ji,jj,jk) / xfastca))      !! how much CaCO3 leaves this box            (mol)
+                        freminca(ji,jj) = (fq0 - fq1) / fse3t(ji,jj,jk)                !! Ca remineralisation in this box           (mol)
                      else
                         !! partial grid cell below CCD
-                        fq2      = fdep1 - ocal_ccd(ji,jj)           !! amount of grid cell below CCD             (m)
+                        fq2      = fdep1(ji,jj) - ocal_ccd(ji,jj)           !! amount of grid cell below CCD             (m)
                         fq1      = fq0 * exp(-(fq2 / xfastca))       !! how much CaCO3 leaves this box            (mol)
-                        freminca = (fq0 - fq1) / fthk                !! Ca remineralisation in this box           (mol)
+                        freminca(ji,jj) = (fq0 - fq1) / fse3t(ji,jj,jk)                !! Ca remineralisation in this box           (mol)
                      endif
                      ffastca(ji,jj) = fq1 
                   else
                      !! this is BELOW THE LAST OCEAN BOX (do nothing)
-                     freminc  = 0.0
-                     freminn  = 0.0
-                     freminfe = 0.0
-                     freminsi = 0.0
-                     freminca = 0.0              
+                     freminc(ji,jj)  = 0.0
+                     freminn(ji,jj)  = 0.0
+                     freminfe(ji,jj) = 0.0
+                     freminsi(ji,jj) = 0.0
+                     freminca(ji,jj) = 0.0              
                   endif
 
@@ -3406,17 +3378,17 @@
                !!
                !! === organic carbon ===                          (diatom and mesozooplankton mortality)
-               ffastc(ji,jj)  = ffastc(ji,jj)  + (ftempc  * fthk)
+               ffastc(ji,jj)  = ffastc(ji,jj)  + (ftempc(ji,jj)  * fse3t(ji,jj,jk))
                !!
                !! === organic nitrogen ===                        (diatom and mesozooplankton mortality)
-               ffastn(ji,jj)  = ffastn(ji,jj)  + (ftempn  * fthk)
+               ffastn(ji,jj)  = ffastn(ji,jj)  + (ftempn(ji,jj)  * fse3t(ji,jj,jk))
                !!
                !! === organic iron ===                            (diatom and mesozooplankton mortality)
-               ffastfe(ji,jj) = ffastfe(ji,jj) + (ftempfe * fthk)
+               ffastfe(ji,jj) = ffastfe(ji,jj) + (ftempfe(ji,jj) * fse3t(ji,jj,jk))
                !!
                !! === biogenic silicon ===                        (diatom mortality and grazed diatoms)
-               ffastsi(ji,jj) = ffastsi(ji,jj) + (ftempsi * fthk)
+               ffastsi(ji,jj) = ffastsi(ji,jj) + (ftempsi(ji,jj) * fse3t(ji,jj,jk))
                !!
                !! === biogenic calcium carbonate ===              (latitudinally-based fraction of total primary production)
-               ffastca(ji,jj) = ffastca(ji,jj) + (ftempca * fthk)
+               ffastca(ji,jj) = ffastca(ji,jj) + (ftempca(ji,jj) * fse3t(ji,jj,jk))
 
                !!----------------------------------------------------------------------
@@ -3456,9 +3428,10 @@
                !!----------------------------------------------------------------------
                !! 
-               ffast2slowc  = 0.0
-               ffast2slown  = 0.0
-               ffast2slowfe = 0.0
-               !!
-               if (jk.eq.jmbathy) then
+               ffast2slowc(ji,jj)  = 0.0
+               ffast2slown(ji,jj)  = 0.0
+! I don't think this is used - marc 10/4/17
+!               ffast2slowfe(ji,jj) = 0.0
+               !!
+               if (jk.eq.mbathy(ji,jj)) then
                   !! this is the BOTTOM OCEAN BOX (remineralise everything)
                   !!
@@ -3467,8 +3440,8 @@
                   !! === organic carbon ===
                   if (jfdfate.eq.0 .and. jorgben.eq.0) then
-                     freminc  = freminc + (ffastc(ji,jj) / fthk)    !! C remineralisation in this box            (mol/m3)
+                     freminc(ji,jj)  = freminc(ji,jj) + (ffastc(ji,jj) / fse3t(ji,jj,jk))    !! C remineralisation in this box            (mol/m3)
                   elseif (jfdfate.eq.1 .and. jorgben.eq.0) then
-                     ffast2slowc = ffastc(ji,jj) / fthk             !! fast C -> slow C                          (mol/m3)
-                     fslowc      = fslowc + ffast2slowc
+                     ffast2slowc(ji,jj) = ffastc(ji,jj) / fse3t(ji,jj,jk)             !! fast C -> slow C                          (mol/m3)
+                     fslowc(ji,jj)      = fslowc(ji,jj) + ffast2slowc(ji,jj)
                   elseif (jfdfate.eq.0 .and. jorgben.eq.1) then
                      f_fbenin_c(ji,jj)  = ffastc(ji,jj)             !! fast C -> benthic C                       (mol/m2)
@@ -3479,8 +3452,8 @@
                   !! === organic nitrogen ===
                   if (jfdfate.eq.0 .and. jorgben.eq.0) then
-                     freminn  = freminn + (ffastn(ji,jj) / fthk)    !! N remineralisation in this box            (mol/m3)
+                     freminn(ji,jj)  = freminn(ji,jj) + (ffastn(ji,jj) / fse3t(ji,jj,jk))    !! N remineralisation in this box            (mol/m3)
                   elseif (jfdfate.eq.1 .and. jorgben.eq.0) then
-                     ffast2slown = ffastn(ji,jj) / fthk             !! fast N -> slow N                          (mol/m3)
-                     fslown      = fslown + ffast2slown
+                     ffast2slown(ji,jj) = ffastn(ji,jj) / fse3t(ji,jj,jk)             !! fast N -> slow N                          (mol/m3)
+                     fslown(ji,jj)      = fslown(ji,jj) + ffast2slown(ji,jj)
                   elseif (jfdfate.eq.0 .and. jorgben.eq.1) then
                      f_fbenin_n(ji,jj)  = ffastn(ji,jj)             !! fast N -> benthic N                       (mol/m2)
@@ -3491,7 +3464,8 @@
                   !! === organic iron ===
                   if (jfdfate.eq.0 .and. jorgben.eq.0) then
-                     freminfe = freminfe + (ffastfe(ji,jj) / fthk)  !! Fe remineralisation in this box           (mol/m3)
-                  elseif (jfdfate.eq.1 .and. jorgben.eq.0) then
-                     ffast2slowfe = ffastn(ji,jj) / fthk            !! fast Fe -> slow Fe                        (mol/m3)
+                     freminfe(ji,jj) = freminfe(ji,jj) + (ffastfe(ji,jj) / fse3t(ji,jj,jk))  !! Fe remineralisation in this box           (mol/m3)
+! I don't think ffast2slowfe is used - marc 10/4/17
+!                  elseif (jfdfate.eq.1 .and. jorgben.eq.0) then
+!                     ffast2slowfe(ji,jj) = ffastn(ji,jj) / fse3t(ji,jj,jk)            !! fast Fe -> slow Fe                        (mol/m3)
                   elseif (jfdfate.eq.0 .and. jorgben.eq.1) then
                      f_fbenin_fe(ji,jj) = ffastfe(ji,jj)            !! fast Fe -> benthic Fe                     (mol/m2)
@@ -3502,5 +3476,5 @@
                   !! === biogenic silicon ===
                   if (jinorgben.eq.0) then
-                     freminsi = freminsi + (ffastsi(ji,jj) / fthk)  !! Si remineralisation in this box           (mol/m3)
+                     freminsi(ji,jj) = freminsi(ji,jj) + (ffastsi(ji,jj) / fse3t(ji,jj,jk))  !! Si remineralisation in this box           (mol/m3)
                   elseif (jinorgben.eq.1) then
                      f_fbenin_si(ji,jj) = ffastsi(ji,jj)            !! fast Si -> benthic Si                     (mol/m2)
@@ -3511,5 +3485,5 @@
                   !! === biogenic calcium carbonate ===
                   if (jinorgben.eq.0) then
-                     freminca = freminca + (ffastca(ji,jj) / fthk)  !! Ca remineralisation in this box           (mol/m3) 
+                     freminca(ji,jj) = freminca(ji,jj) + (ffastca(ji,jj) / fse3t(ji,jj,jk))  !! Ca remineralisation in this box           (mol/m3) 
                   elseif (jinorgben.eq.1) then
                      f_fbenin_ca(ji,jj) = ffastca(ji,jj)            !! fast Ca -> benthic Ca                     (mol/m2)
@@ -3525,9 +3499,9 @@
                   !!----------------------------------------------------------------------
                   !!
-                  fofd_n(ji,jj)  = fofd_n(ji,jj)  + (freminn  * fthk)
-                  fofd_si(ji,jj) = fofd_si(ji,jj) + (freminsi * fthk)
-                  fofd_fe(ji,jj) = fofd_fe(ji,jj) + (freminfe * fthk)
+                  fofd_n(ji,jj)  = fofd_n(ji,jj)  + (freminn(ji,jj)  * fse3t(ji,jj,jk))
+                  fofd_si(ji,jj) = fofd_si(ji,jj) + (freminsi(ji,jj) * fse3t(ji,jj,jk))
+                  fofd_fe(ji,jj) = fofd_fe(ji,jj) + (freminfe(ji,jj) * fse3t(ji,jj,jk))
 #  if defined key_roam
-                  fofd_c(ji,jj)  = fofd_c(ji,jj)  + (freminc  * fthk)
+                  fofd_c(ji,jj)  = fofd_c(ji,jj)  + (freminc(ji,jj)  * fse3t(ji,jj,jk))
 #  endif
                endif
@@ -3539,8 +3513,8 @@
                !!
                !! update fast-sinking regeneration arrays
-               fregenfast(ji,jj)   = fregenfast(ji,jj)   + (freminn  * fthk)
-               fregenfastsi(ji,jj) = fregenfastsi(ji,jj) + (freminsi * fthk)
+               fregenfast(ji,jj)   = fregenfast(ji,jj)   + (freminn(ji,jj)  * fse3t(ji,jj,jk))
+               fregenfastsi(ji,jj) = fregenfastsi(ji,jj) + (freminsi(ji,jj) * fse3t(ji,jj,jk))
 # if defined key_roam
-               fregenfastc(ji,jj)  = fregenfastc(ji,jj)  + (freminc  * fthk)
+               fregenfastc(ji,jj)  = fregenfastc(ji,jj)  + (freminc(ji,jj)  * fse3t(ji,jj,jk))
 # endif
 
@@ -3549,5 +3523,5 @@
                !!----------------------------------------------------------------------
                !!
-               if (jk.eq.jmbathy) then
+               if (jk.eq.mbathy(ji,jj)) then
                   !!
                   !! organic components
@@ -3564,5 +3538,5 @@
                      !!
                      !! account for CaCO3 that dissolves when it shouldn't
-                     if ( fdep .le. fccd_dep ) then
+                     if ( fsdepw(ji,jj,jk) .le. fccd_dep(ji,jj) ) then
                         f_benout_lyso_ca(ji,jj) = xsedca * zn_sed_ca(ji,jj)
                      endif
@@ -3581,61 +3555,61 @@
                !!----------------------------------------------------------------------
                !! chlorophyll
-               btra(jpchn) = b0 * ( &
-                 + ((frn * fprn * zphn) - fgmipn - fgmepn - fdpn - fdpn2) * (fthetan / xxi) )
-               btra(jpchd) = b0 * ( &
-                 + ((frd * fprd * zphd) - fgmepd - fdpd - fdpd2) * (fthetad / xxi) )
+               btra(ji,jj,jpchn) = b0 * ( &
+                 + ((frn(ji,jj) * fprn(ji,jj) * zphn(ji,jj)) - fgmipn(ji,jj) - fgmepn(ji,jj) - fdpn(ji,jj) - fdpn2(ji,jj)) * (fthetan(ji,jj) / xxi) )
+               btra(ji,jj,jpchd) = b0 * ( &
+                 + ((frd(ji,jj) * fprd(ji,jj) * zphd(ji,jj)) - fgmepd(ji,jj) - fdpd(ji,jj) - fdpd2(ji,jj)) * (fthetad(ji,jj) / xxi) )
                !!
                !!----------------------------------------------------------------------
                !! phytoplankton
-               btra(jpphn) = b0 * ( &
-                 + (fprn * zphn) - fgmipn - fgmepn - fdpn - fdpn2 )
-               btra(jpphd) = b0 * ( &
-                 + (fprd * zphd) - fgmepd - fdpd - fdpd2 )
-               btra(jppds) = b0 * ( &
-                 + (fprds * zpds) - fgmepds - fdpds - fsdiss - fdpds2 )
+               btra(ji,jj,jpphn) = b0 * ( &
+                 + (fprn(ji,jj) * zphn(ji,jj)) - fgmipn(ji,jj) - fgmepn(ji,jj) - fdpn(ji,jj) - fdpn2(ji,jj) )
+               btra(ji,jj,jpphd) = b0 * ( &
+                 + (fprd(ji,jj) * zphd(ji,jj)) - fgmepd(ji,jj) - fdpd(ji,jj) - fdpd2(ji,jj) )
+               btra(ji,jj,jppds) = b0 * ( &
+                 + (fprds(ji,jj) * zpds(ji,jj)) - fgmepds(ji,jj) - fdpds(ji,jj) - fsdiss(ji,jj) - fdpds2(ji,jj) )
                !!
                !!----------------------------------------------------------------------
                !! zooplankton
-               btra(jpzmi) = b0 * ( &
-                 + fmigrow - fgmezmi - fdzmi - fdzmi2 )
-               btra(jpzme) = b0 * ( &
-                 + fmegrow - fdzme - fdzme2 )
+               btra(ji,jj,jpzmi) = b0 * ( &
+                 + fmigrow(ji,jj) - fgmezmi(ji,jj) - fdzmi(ji,jj) - fdzmi2(ji,jj) )
+               btra(ji,jj,jpzme) = b0 * ( &
+                 + fmegrow(ji,jj) - fdzme(ji,jj) - fdzme2(ji,jj) )
                !!
                !!----------------------------------------------------------------------
                !! detritus
-               btra(jpdet) = b0 * ( &
-                 + fdpn + ((1.0 - xfdfrac1) * fdpd)              &  ! mort. losses
-                 + fdzmi + ((1.0 - xfdfrac2) * fdzme)            &  ! mort. losses
-                 + ((1.0 - xbetan) * (finmi + finme))            &  ! assim. inefficiency
-                 - fgmid - fgmed - fdd                           &  ! grazing and remin.
-                 + ffast2slown )                                    ! seafloor fast->slow
+               btra(ji,jj,jpdet) = b0 * ( &
+                 + fdpn(ji,jj) + ((1.0 - xfdfrac1) * fdpd(ji,jj))              &  ! mort. losses
+                 + fdzmi(ji,jj) + ((1.0 - xfdfrac2) * fdzme(ji,jj))            &  ! mort. losses
+                 + ((1.0 - xbetan) * (finmi(ji,jj) + finme(ji,jj)))            &  ! assim. inefficiency
+                 - fgmid(ji,jj) - fgmed(ji,jj) - fdd(ji,jj)                           &  ! grazing and remin.
+                 + ffast2slown(ji,jj) )                                    ! seafloor fast->slow
                !!
                !!----------------------------------------------------------------------
                !! dissolved inorganic nitrogen nutrient
                fn_cons = 0.0  &
-                 - (fprn * zphn) - (fprd * zphd)                    ! primary production
+                 - (fprn(ji,jj) * zphn(ji,jj)) - (fprd(ji,jj) * zphd(ji,jj))                    ! primary production
                fn_prod = 0.0  &
-                 + (xphi * (fgmipn + fgmid))                     &  ! messy feeding remin.
-                 + (xphi * (fgmepn + fgmepd + fgmezmi + fgmed))  &  ! messy feeding remin.
-                 + fmiexcr + fmeexcr + fdd + freminn             &  ! excretion and remin.
-                 + fdpn2 + fdpd2 + fdzmi2 + fdzme2                  ! metab. losses
+                 + (xphi * (fgmipn(ji,jj) + fgmid(ji,jj)))                     &  ! messy feeding remin.
+                 + (xphi * (fgmepn(ji,jj) + fgmepd(ji,jj) + fgmezmi(ji,jj) + fgmed(ji,jj)))  &  ! messy feeding remin.
+                 + fmiexcr(ji,jj) + fmeexcr(ji,jj) + fdd(ji,jj) + freminn(ji,jj)             &  ! excretion and remin.
+                 + fdpn2(ji,jj) + fdpd2(ji,jj) + fdzmi2(ji,jj) + fdzme2(ji,jj)                  ! metab. losses
                !! 
                !! riverine flux
                if ( jriver_n .gt. 0 ) then
-                  f_riv_loc_n = f_riv_n(ji,jj) * friver_dep(jk,jmbathy) / fthk
-                  fn_prod = fn_prod + f_riv_loc_n
+                  f_riv_loc_n(ji,jj) = f_riv_n(ji,jj) * friver_dep(jk,mbathy(ji,jj)) / fse3t(ji,jj,jk)
+                  fn_prod = fn_prod + f_riv_loc_n(ji,jj)
                endif
                !!  
                !! benthic remineralisation
-               if (jk.eq.jmbathy .and. jorgben.eq.1 .and. ibenthic.eq.1) then
-                  fn_prod = fn_prod + (f_benout_n(ji,jj) / fthk)
+               if (jk.eq.mbathy(ji,jj) .and. jorgben.eq.1 .and. ibenthic.eq.1) then
+                  fn_prod = fn_prod + (f_benout_n(ji,jj) / fse3t(ji,jj,jk))
                endif
                !!
-               btra(jpdin) = b0 * ( &
+               btra(ji,jj,jpdin) = b0 * ( &
                  fn_prod + fn_cons )
                !!
-               fnit_cons(ji,jj) = fnit_cons(ji,jj) + ( fthk * (  &  ! consumption of dissolved nitrogen
+               fnit_cons(ji,jj) = fnit_cons(ji,jj) + ( fse3t(ji,jj,jk) * (  &  ! consumption of dissolved nitrogen
                  fn_cons ) )
-               fnit_prod(ji,jj) = fnit_prod(ji,jj) + ( fthk * (  &  ! production of dissolved nitrogen
+               fnit_prod(ji,jj) = fnit_prod(ji,jj) + ( fse3t(ji,jj,jk) * (  &  ! production of dissolved nitrogen
                  fn_prod ) )
                !!
@@ -3643,34 +3617,34 @@
                !! dissolved silicic acid nutrient
                fs_cons = 0.0  &
-                 - (fprds * zpds)                                   ! opal production
+                 - (fprds(ji,jj) * zpds(ji,jj))                                   ! opal production
                fs_prod = 0.0  &
-                 + fsdiss                                        &  ! opal dissolution
-                 + ((1.0 - xfdfrac1) * fdpds)                    &  ! mort. loss
-                 + ((1.0 - xfdfrac3) * fgmepds)                  &  ! egestion of grazed Si
-                 + freminsi + fdpds2                                ! fast diss. and metab. losses
+                 + fsdiss(ji,jj)                                        &  ! opal dissolution
+                 + ((1.0 - xfdfrac1) * fdpds(ji,jj))                    &  ! mort. loss
+                 + ((1.0 - xfdfrac3) * fgmepds(ji,jj))                  &  ! egestion of grazed Si
+                 + freminsi(ji,jj) + fdpds2(ji,jj)                                ! fast diss. and metab. losses
                !! 
                !! riverine flux
                if ( jriver_si .gt. 0 ) then
-                  f_riv_loc_si = f_riv_si(ji,jj) * friver_dep(jk,jmbathy) / fthk
-                  fs_prod = fs_prod + f_riv_loc_si
+                  f_riv_loc_si(ji,jj) = f_riv_si(ji,jj) * friver_dep(jk,mbathy(ji,jj)) / fse3t(ji,jj,jk)
+                  fs_prod = fs_prod + f_riv_loc_si(ji,jj)
                endif
                !!  
                !! benthic remineralisation
-               if (jk.eq.jmbathy .and. jinorgben.eq.1 .and. ibenthic.eq.1) then
-                  fs_prod = fs_prod + (f_benout_si(ji,jj) / fthk)
+               if (jk.eq.mbathy(ji,jj) .and. jinorgben.eq.1 .and. ibenthic.eq.1) then
+                  fs_prod = fs_prod + (f_benout_si(ji,jj) / fse3t(ji,jj,jk))
                endif
                !!
-               btra(jpsil) = b0 * ( &
+               btra(ji,jj,jpsil) = b0 * ( &
                  fs_prod + fs_cons )
                !!
-               fsil_cons(ji,jj) = fsil_cons(ji,jj) + ( fthk * (  &  ! consumption of dissolved silicon
+               fsil_cons(ji,jj) = fsil_cons(ji,jj) + ( fse3t(ji,jj,jk) * (  &  ! consumption of dissolved silicon
                  fs_cons ) )
-               fsil_prod(ji,jj) = fsil_prod(ji,jj) + ( fthk * (  &  ! production of dissolved silicon
+               fsil_prod(ji,jj) = fsil_prod(ji,jj) + ( fse3t(ji,jj,jk) * (  &  ! production of dissolved silicon
                  fs_prod ) )
                !!
                !!----------------------------------------------------------------------
                !! dissolved "iron" nutrient
-               btra(jpfer) = b0 * ( &
-               + (xrfn * btra(jpdin)) + ffetop + ffebot - ffescav )
+               btra(ji,jj,jpfer) = b0 * ( &
+               + (xrfn * btra(ji,jj,jpdin)) + ffetop(ji,jj) + ffebot(ji,jj) - ffescav(ji,jj) )
 
 # if defined key_roam
@@ -3678,35 +3652,35 @@
                !!----------------------------------------------------------------------
                !! AXY (26/11/08): implicit detrital carbon change
-               btra(jpdtc) = b0 * ( &
-                 + (xthetapn * fdpn) + ((1.0 - xfdfrac1) * (xthetapd * fdpd))      &  ! mort. losses
-                 + (xthetazmi * fdzmi) + ((1.0 - xfdfrac2) * (xthetazme * fdzme))  &  ! mort. losses
-                 + ((1.0 - xbetac) * (ficmi + ficme))                              &  ! assim. inefficiency
-                 - fgmidc - fgmedc - fddc                                          &  ! grazing and remin.
-                 + ffast2slowc )                                                      ! seafloor fast->slow
+               btra(ji,jj,jpdtc) = b0 * ( &
+                 + (xthetapn * fdpn(ji,jj)) + ((1.0 - xfdfrac1) * (xthetapd * fdpd(ji,jj)))      &  ! mort. losses
+                 + (xthetazmi * fdzmi(ji,jj)) + ((1.0 - xfdfrac2) * (xthetazme * fdzme(ji,jj)))  &  ! mort. losses
+                 + ((1.0 - xbetac) * (ficmi(ji,jj) + ficme(ji,jj)))                              &  ! assim. inefficiency
+                 - fgmidc(ji,jj) - fgmedc(ji,jj) - fddc(ji,jj)                                          &  ! grazing and remin.
+                 + ffast2slowc(ji,jj) )                                                      ! seafloor fast->slow
                !!
                !!----------------------------------------------------------------------
                !! dissolved inorganic carbon
                fc_cons = 0.0  &
-                 - (xthetapn * fprn * zphn) - (xthetapd * fprd * zphd)                ! primary production
+                 - (xthetapn * fprn(ji,jj) * zphn(ji,jj)) - (xthetapd * fprd(ji,jj) * zphd(ji,jj))                ! primary production
                fc_prod = 0.0  &
-                 + (xthetapn * xphi * fgmipn) + (xphi * fgmidc)                    &  ! messy feeding remin
-                 + (xthetapn * xphi * fgmepn) + (xthetapd * xphi * fgmepd)         &  ! messy feeding remin
-                 + (xthetazmi * xphi * fgmezmi) + (xphi * fgmedc)                  &  ! messy feeding remin
-                 + fmiresp + fmeresp + fddc + freminc + (xthetapn * fdpn2)         &  ! resp., remin., losses
-                 + (xthetapd * fdpd2) + (xthetazmi * fdzmi2)                       &  ! losses
-                 + (xthetazme * fdzme2)                                               ! losses
+                 + (xthetapn * xphi * fgmipn(ji,jj)) + (xphi * fgmidc(ji,jj))                    &  ! messy feeding remin
+                 + (xthetapn * xphi * fgmepn(ji,jj)) + (xthetapd * xphi * fgmepd(ji,jj))         &  ! messy feeding remin
+                 + (xthetazmi * xphi * fgmezmi(ji,jj)) + (xphi * fgmedc(ji,jj))                  &  ! messy feeding remin
+                 + fmiresp(ji,jj) + fmeresp(ji,jj) + fddc(ji,jj) + freminc(ji,jj) + (xthetapn * fdpn2(ji,jj))         &  ! resp., remin., losses
+                 + (xthetapd * fdpd2(ji,jj)) + (xthetazmi * fdzmi2(ji,jj))                       &  ! losses
+                 + (xthetazme * fdzme2(ji,jj))                                               ! losses
                !! 
                !! riverine flux
                if ( jriver_c .gt. 0 ) then
-                  f_riv_loc_c = f_riv_c(ji,jj) * friver_dep(jk,jmbathy) / fthk
-                  fc_prod = fc_prod + f_riv_loc_c
+                  f_riv_loc_c(ji,jj) = f_riv_c(ji,jj) * friver_dep(jk,mbathy(ji,jj)) / fse3t(ji,jj,jk)
+                  fc_prod = fc_prod + f_riv_loc_c(ji,jj)
                endif
                !!  
                !! benthic remineralisation
-               if (jk.eq.jmbathy .and. jorgben.eq.1 .and. ibenthic.eq.1) then
-                  fc_prod = fc_prod + (f_benout_c(ji,jj) / fthk)
+               if (jk.eq.mbathy(ji,jj) .and. jorgben.eq.1 .and. ibenthic.eq.1) then
+                  fc_prod = fc_prod + (f_benout_c(ji,jj) / fse3t(ji,jj,jk))
                endif
-               if (jk.eq.jmbathy .and. jinorgben.eq.1 .and. ibenthic.eq.1) then
-                  fc_prod = fc_prod + (f_benout_ca(ji,jj) / fthk)
+               if (jk.eq.mbathy(ji,jj) .and. jinorgben.eq.1 .and. ibenthic.eq.1) then
+                  fc_prod = fc_prod + (f_benout_ca(ji,jj) / fse3t(ji,jj,jk))
                endif
                !!
@@ -3715,5 +3689,5 @@
                !!
                !! CaCO3
-               fc_prod = fc_prod - ftempca + freminca
+               fc_prod = fc_prod - ftempca(ji,jj) + freminca(ji,jj)
                !! 
                !! riverine flux
@@ -3722,10 +3696,10 @@
                endif
                !!
-               btra(jpdic) = b0 * ( &
+               btra(ji,jj,jpdic) = b0 * ( &
                  fc_prod + fc_cons )
                !!
-               fcar_cons(ji,jj) = fcar_cons(ji,jj) + ( fthk * (  &  ! consumption of dissolved carbon
+               fcar_cons(ji,jj) = fcar_cons(ji,jj) + ( fse3t(ji,jj,jk) * (  &  ! consumption of dissolved carbon
                  fc_cons ) )
-               fcar_prod(ji,jj) = fcar_prod(ji,jj) + ( fthk * (  &  ! production of dissolved carbon
+               fcar_prod(ji,jj) = fcar_prod(ji,jj) + ( fse3t(ji,jj,jk) * (  &  ! production of dissolved carbon
                  fc_prod ) )
                !!
